//(c) 2016 Dmitry Grinberg   http://dmitry.gr   me@dmitry.gr   see LICENSE.txt

#ifndef _COMMS_H_
#define _COMMS_H_

#ifndef WIN32
#include <stdint.h>
#endif

#define COMMS_DATA_TX_SZ		1536

#ifndef PACKED_START
	#define PACKED_START
	#define PACKED_MID		__attribute__((packed))
	#define PACKED_END	
#endif

PACKED_START
struct CommsPacket {
	uint8_t cmd;
	uint8_t crc;
	PACKED_START
	union {
		PACKED_START
		struct  PACKED_MID {
			uint32_t version;
			uint8_t compatible;	//boolean dut of fixed size ;)
			uint32_t key;
			uint32_t magicval;
			uint32_t flashSz;
			uint32_t flashErzBlkSz;
		} info;
		PACKED_END
		PACKED_START
		struct  PACKED_MID {
			uint32_t addr;
		} erase;
		PACKED_END
		PACKED_START
		struct  PACKED_MID {
			uint32_t addr;
			uint8_t bytes[COMMS_DATA_TX_SZ];
		} data;
		PACKED_END
		uint8_t success;
		uint8_t on;	//for vpp_contorl
	} PACKED_MID ; PACKED_END
} PACKED_MID ; PACKED_END

#define PACKET_TYPE_GET_INFO	0x00
#define PACKET_TYPE_DO_ERASE	0x01
#define PACKET_TYPE_DO_WRITE	0x02
#define PACKET_TYPE_DO_READ		0x03
#define PACKET_TYPE_VPP_CTRL	0x04


static uint8_t commsPacketCalc(const struct CommsPacket* pkt)
{
	const unsigned char *p = (const unsigned char*)pkt;
	uint16_t i;
	uint8_t crc = 0xff;
	
	for (i = 0; i < sizeof(struct CommsPacket); i++, p++) {
		
		//skip crc byte itself
		if (p == (const unsigned char*)&pkt->crc)
			continue;
		
		crc = (crc << 1) ^ ((crc & 0x80) ? 0xB1 : 0x00) ^ p[0];
	}
	
	return crc;
}


#endif
