//(c) 2016 Dmitry Grinberg   http://dmitry.gr   me@dmitry.gr   see LICENSE.txt

#ifndef _HW_H_
#define _HW_H_

#include <avr/io.h>
#include <stdbool.h>
#include <stdint.h>

//init
void extHwInit(void);



//internal utility

static void porteCtrl(bool on, uint8_t bit)
{
	if (on)
		PORTE |= bit;
	else
		PORTE &=~ bit;
}



//LED

static void extHwLed(bool on)
{
	porteCtrl(on, 0x80);
}


//flash addr bus

static void extHwSetAddr(uint32_t addr)
{
	PORTF = (uint8_t)addr;
	addr >>= 8;
	PORTD = (uint8_t)addr;
	addr >>= 8;
	PORTC = (PORTC & 0xC0) | ((uint8_t)addr);
}

static void extHwIncrAddr(void)
{
	if (++PORTF)
		return;
	if (++PORTD)
		return;
	PORTC = (PORTC & 0xC0) | ((PORTC + 1) & 0x3F);
}



//flash data bus

static void extHwDataPinsMode(bool output)
{
	if (output)
		DDRA = 0xff;
	else
		DDRA = 0x00;
}

static uint8_t extHwDataRead(void)
{
	return PINA;
}

static void extHwDataWrite(uint8_t val)
{
	PORTA = val;
}


//flash controls

static void extHwVpp(bool on)
{
	porteCtrl(on, 0x01);
}

static void extHwOePin(bool high)
{
	porteCtrl(high, 0x10);
}

static void extHwWePin(bool high)
{
	porteCtrl(high, 0x04);
}

static void extHwCePin(bool high)
{
	porteCtrl(high, 0x40);
}

static bool extHwRyRead(void)
{
	return !!(PINE & 0x20);
}




#endif
