//(c) 2016 Dmitry Grinberg   http://dmitry.gr   me@dmitry.gr   see LICENSE.txt

#ifndef _WINCOMPAT_H_
#define _WINCOMPAT_H_

#ifdef WIN32
	
	#define _CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES	1
	#define _CRT_SECURE_NO_DEPRECATE	1
	
	#include <windows.h>
	#include <stdio.h>
	#include <io.h>
	
	typedef char bool;
	#define false	0
	#define true	1
	
	
	typedef unsigned __int8 uint8_t;
	typedef unsigned __int16 uint16_t;
	typedef unsigned __int32 uint32_t;
	typedef unsigned __int64 uint64_t;
	
	typedef signed __int8 int8_t;
	typedef signed __int16 int16_t;
	typedef signed __int32 int32_t;
	typedef signed __int64 int64_t;
	
	#define PACKED_START	__pragma( pack(push, 1) )
	#define PACKED_MID
	#define PACKED_END		__pragma( pack(pop) )
	
	#define isatty _isatty
	#define fileno _fileno

#else

	#include <stdbool.h>
	#include <stdint.h>
	#include <unistd.h>
	
	#define PACKED_START
	#define PACKED_MID		__attribute__((packed))
	#define PACKED_END		
	
#endif


#endif
